#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <stdarg.h>
#include <sys/ioctl.h>
#include <asm/termbits.h>
// #include <termios.h>

/*
#include <stdio.h>
#include <fcntl.h>
// #include <termios.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <asm/termbits.h>
*/

/*
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <stdarg.h>
#include <sys/ioctl.h>
#include <asm/termbits.h>
*/

#if 0
struct termios2 {
	tcflag_t c_iflag;	/* input mode flags */
	tcflag_t c_oflag;	/* output mode flags */
	tcflag_t c_cflag;	/* control mode flags */
	tcflag_t c_lflag;	/* local mode flags */
	cc_t c_line;		/* line discipline */
	cc_t c_cc[NCCS];	/* control characters */
	speed_t c_ispeed;	/* input speed */
	speed_t c_ospeed;	/* output speed */
};
#endif

#define	BOTHER 0010000

int set_interface_attribs(int fd, unsigned int baud)
{
	int ret;

#if 0

// 	int fd; /* port file descriptor */
// 	char port[20] = "/dev/ttyACM0"; /* port to connect to */

// 	fd = open(port, O_RDWR); /* connect to port */

	/* set the other settings (in this case, 9600 8N1) */
	struct termios settings;

	memset (&settings, 0, sizeof(settings));

	ret = tcgetattr(fd, &settings);
	if (ret != 0) {
		fprintf(stderr,"tcgetattr, error %d\n", errno);
		return errno;
	}

	ret = cfsetospeed(&settings, (speed_t)baud); /* baud rate */
	if (ret != 0) {
		fprintf(stderr,"cfsetospeed, error %d\n", errno);
		return errno;
	}

	settings.c_cflag &= ~(PARENB | PARODD); /* no parity */
	settings.c_cflag &= ~CSTOPB; /* 1 stop bit */
	settings.c_cflag &= ~CSIZE;
	settings.c_cflag |= CS8 | CLOCAL | CREAD; /* 8 bits */
	settings.c_cflag &= ~CRTSCTS;	/* no control lines */
	settings.c_oflag &= ~OPOST; /* raw output */
	settings.c_iflag &= ~(IXON | IXOFF | IXANY);
	settings.c_iflag &= ~IGNBRK; /* disable break ?? */
	settings.c_lflag = ICANON; /* canonical mode */

	ret = tcsetattr(fd, TCSANOW, &settings); /* apply the settings */
	if (ret != 0) {
		fprintf(stderr,"tcsetattr, error %d\n", errno);
		return errno;
	}

	ret = tcflush(fd, TCOFLUSH);
	if (ret != 0) {
		fprintf(stderr,"tcflush, error %d\n", errno);
		return errno;
	}

	#endif


	struct termios2 term2;

	ret = ioctl(fd, TCGETS2, &term2);
	if (ret != 0) {
		fprintf(stderr,"TCGETS2, error %d\n", errno);
		return errno;
	}

	term2.c_lflag &= ~ICANON; /* canonical mode */

	term2.c_oflag &= ~OPOST; /* raw output */

	term2.c_iflag &= ~(BRKINT | PARMRK | ISTRIP | INLCR | IGNCR | ICRNL);
	term2.c_iflag &= ~(IXON | IXOFF | IXANY);
//	term2.c_iflag &= ~IGNBRK; /* disable break ?? */
	term2.c_iflag |= IGNBRK; /* disable break ?? */

	term2.c_cflag &= ~(PARENB | PARODD); /* no parity */
	term2.c_cflag &= ~CSTOPB; /* 1 stop bit */
	term2.c_cflag &= ~CSIZE;
	term2.c_cflag &= ~(ECHO | ECHOE | ECHOK | ECHOCTL | ECHOPRT | ECHOKE);
	term2.c_cflag |= CS8 | CLOCAL | CREAD; /* 8 bits */
	term2.c_cflag &= ~CRTSCTS;	/* no control lines */
	//!!
	term2.c_cflag &= ~CBAUD;  /* Remove current BAUD rate */
	term2.c_cflag |= BOTHER;  /* Allow custom BAUD rate using int input */

	term2.c_ispeed = baud;   /* Set the input BAUD rate */
	term2.c_ospeed = baud;   /* Set the output BAUD rate */

	ret = ioctl(fd, TCSETS2, &term2);
	if (ret != 0) {
		fprintf(stderr,"TCSETS2, error %d\n", errno);
		return errno;
	}

	#if 0
	ret = ioctl(fd, TCSETS2, &term2);
	if (ret != 0) {
		fprintf(stderr,"TCSETS2, error %d\n", errno);
		return errno;
	}
	#endif

	ret = ioctl(fd, TCFLSH, 0);
	if (ret != 0) {
		fprintf(stderr,"TCFLSH, error %d\n", errno);
		return errno;
	}

#if 0
	ret = tcflush(fd, TCOFLUSH);
	if (ret != 0) {
		fprintf(stderr,"tcflush, error %d\n", errno);
		return errno;
	}
#endif
	return 0;
	/* — code to use the port here — */

// 	close(fd); /* cleanup */
}


int get_interface_attribs(int fd)
{
// 	struct termios tty;
// 	memset (&tty, 0, sizeof tty);

	struct termios2 term2;
	int ret;

	ret = ioctl(fd, TCGETS2, &term2);
	if (ret != 0) {
		fprintf(stderr,"TCGETS2, error %d\n", errno);
		return errno;
	}

/*
ioctl(3, TCGETS,
{c_iflags=0x1,
c_oflags=0,
c_cflags=0x1880,
c_lflags=0,
c_line=0,
c_cc[VMIN]=1,
c_cc[VTIME]=5,
c_cc="\x03\x1c\x7f\x15\x04\x05\x01\x00\x11\x13\x1a\x00\x12\x0f\x17\x16\x00\x00\x00"}) = 0
*/

	printf("termios2 0x%04hx 0x%04hx 0x%04hx 0x%04hx 0x%02hhx\n",
		term2.c_iflag,
		term2.c_oflag,
		term2.c_cflag,
		term2.c_lflag,
		term2.c_line
	);
//VMIN = 6
//VTIME = 5
	for (int i=0;i<19;i++) {
		printf("0x%02hhx ",term2.c_cc[i]);
	}
	printf("\n");


/*
	if (tcgetattr(fd, &tty) != 0) {
		fprintf(stderr,"tcgetattr, error %d\n", errno);
		return errno;
	}
	return cfgetispeed(&tty);
*/

	return term2.c_ispeed;
}


//UART timeout control, min read
int set_blocking(
	int fd,
	unsigned char min_bytes,
	unsigned char timeout)
{
	struct termios2 term2;
	int ret;

	ret = ioctl(fd, TCGETS2, &term2);
	if (ret != 0) {
		fprintf(stderr,"TCGETS2, error %d\n", errno);
		return errno;
	}

	term2.c_cc[VMIN]  = min_bytes;	//min to wait/start timeout
	term2.c_cc[VTIME] = timeout;	//0.1s timeout between

	ret = ioctl(fd, TCSETS2, &term2);
	if (ret != 0) {
		fprintf(stderr,"TCSETS2, error %d\n", errno);
		return errno;
	}

	ret = ioctl(fd, TCFLSH, 0);
	if (ret != 0) {
		fprintf(stderr,"TCFLSH, error %d\n", errno);
		return errno;
	}

	return 0;
}
